#!/usr/bin/perl -w

package Adresar;

BEGIN {
    use src::MymoneyUI;
};


use strict;


#use Encode;
use utf8;
#use open ':utf8', ':std';

use Gtk2;
init Gtk2;
use Gtk2::SimpleList;

use lib "./";
use lib::KartaSkupinyAdresare;
use lib::KartaAdresare;
use lib::KartaKontaktniOsoby;
use lib::Dialog;
use lib::Databaze;

my $MyUI;
my %MyMoney;
my @retval=();

sub run {
    my ($self,%params) = @_;
    #my %params=%{$par};
    @retval=();
    $MyUI=$self;
    %MyMoney=%{$params{'cfg'}};
    $self->{'selection_mode'}=$params{'selection_mode'};
    @{$self->{'selected_firmy'}}=@{$params{'selected_firmy'}};
    
    $MyUI->{'TOPFORM'}=$MyUI->FORM->{'vbox261'};
    
    $MyUI->FORM->{'list_skupiny'}=Gtk2::SimpleList->new('Nazev'=>'text','Pořadí'=>'int');
    $MyUI->FORM->{'list_skupiny'}->set_events(['button_press_mask']);
    $MyUI->FORM->{'list_skupiny'}->signal_connect("button_press_event","list_skupiny_menu_activate");
    $MyUI->FORM->{'list_skupiny'}->set_headers_visible('1');
    $MyUI->FORM->{'scrolledwindow_skupiny'}->add($MyUI->FORM->{'list_skupiny'});
    $MyUI->FORM->{'list_skupiny'}->show;
    $MyUI->FORM->{'list_skupiny'}->set_enable_search('1');
    $MyUI->FORM->{'list_skupiny'}->set_reorderable('0');
    $MyUI->FORM->{'list_skupiny'}->set_rules_hint('1');
    $MyUI->FORM->{'list_skupiny'}->columns_autosize;
    $MyUI->FORM->{'list_skupiny'}->get_selection->set_mode('multiple');
    $MyUI->FORM->{'list_skupiny'}->get_selection->signal_connect('changed','skupiny_selection_changed');
    $MyUI->FORM->{'list_skupiny'}->signal_connect("row-activated"=>"upravit_skupinu");
    my $i=0;
    foreach my $column ($MyUI->FORM->{'list_skupiny'}->get_columns) {
        $column->set_resizable(1);
        $column->set_clickable(1);
        $column->set_sort_indicator(0);
        $column->set_sort_column_id($i);
        $column->set_min_width(10);
        $i++;
    };

    $MyUI->FORM->{'list_firmy'}=Gtk2::SimpleList->new(' '=>'bool','Nazev - provozovna'=>'text','Kod partnera (EAN)'=>'text','Cislo'=>'int','Nazev - obch. jmeno'=>'text','Ulice - obch. jmeno'=>'text','Mesto - obch. jmeno'=>'text','PSC - obch. jmeno'=>'text','Stat - obch. jmeno'=>'text','Kod statu - obch. jmeno'=>'text','Ulice - provozovna'=>'text','Mesto - provozovna'=>'text','PSC - provozovna'=>'text','Stat - provozovna'=>'text','Kod statu - provozovna'=>'text','Tel. pred.'=>'text','Tel.'=>'text','Tel. klap.'=>'text','Fax pred.'=>'text','Fax'=>'text','Fax klap.'=>'text','E-mail'=>'text','WWW'=>'text','Mobil pred.'=>'text','Mobil'=>'text','ICO'=>'text','DIC'=>'text','Dat. posl. pohledavky'=>'text','Posl. pohledavka'=>'text','Cislo uctu'=>'text','Kod banky'=>'text','Firma je soukr. osoba'=>'text');
    $MyUI->FORM->{'list_firmy'}->set_events(['button_press_mask']);
    $MyUI->FORM->{'list_firmy'}->signal_connect("button_press_event","list_firmy_menu_activate");
    $MyUI->FORM->{'list_firmy'}->set_headers_visible('1');
    $MyUI->FORM->{'scrolledwindow_firmy'}->add($MyUI->FORM->{'list_firmy'});
    $MyUI->FORM->{'list_firmy'}->show;
    $MyUI->FORM->{'list_firmy'}->set_enable_search('1');
    $MyUI->FORM->{'list_firmy'}->set_reorderable('0');
    $MyUI->FORM->{'list_firmy'}->set_rules_hint('1');
    $MyUI->FORM->{'list_firmy'}->columns_autosize;
    $MyUI->FORM->{'list_firmy'}->get_selection->set_mode('multiple');
    $MyUI->FORM->{'list_firmy'}->get_selection->signal_connect('changed','firmy_selection_changed');
    if($self->{'selection_mode'} eq "none") {
        $MyUI->FORM->{'list_firmy'}->signal_connect("row-activated"=>"upravit_firmu");
    } else {
        $MyUI->FORM->{'list_firmy'}->signal_connect("row-activated"=>"vybrat_firmu");
    };
    $i=0;
    foreach my $column ($MyUI->FORM->{'list_firmy'}->get_columns) {
        if($i!=0) {
            $column->set_resizable(1);
            $column->set_clickable(1);
            $column->set_sort_indicator(0);
            $column->set_sort_column_id($i);
            $column->set_min_width(10);
        } else {
            if(($self->{'selection_mode'} eq 'single') || ($self->{'selection_mode'} eq 'multiple')) {
                $column->set_visible(1);
            } else {
                $column->set_visible(0);
            };
        };
        $i++;
    };

    $MyUI->FORM->{'list_osoby'}=Gtk2::SimpleList->new('Prijmeni'=>'text','Jmeno'=>'text','Kod partnera (EAN)'=>'text','Funkce'=>'text','Ulice'=>'text','Mesto'=>'text','PSC'=>'text','Stat'=>'text','Tel. pred.'=>'text','Tel.'=>'text','Tel. klap.'=>'text','Fax pred.'=>'text','Fax'=>'text','Fax klap.'=>'text','E-mail'=>'text','Mobil pred.'=>'text','Mobil'=>'text','Firma'=>'text','Majitel firmy'=>'text','Cislo'=>'int');
    $MyUI->FORM->{'list_osoby'}->set_events(['button_press_mask']);
    $MyUI->FORM->{'list_osoby'}->signal_connect("button_press_event","list_osoby_menu_activate");
    $MyUI->FORM->{'list_osoby'}->set_headers_visible('1');
    $MyUI->FORM->{'scrolledwindow_osoby'}->add($MyUI->FORM->{'list_osoby'});
    $MyUI->FORM->{'list_osoby'}->show;
    $MyUI->FORM->{'list_osoby'}->set_enable_search('1');
    $MyUI->FORM->{'list_osoby'}->set_reorderable('0');
    $MyUI->FORM->{'list_osoby'}->set_rules_hint('1');
    $MyUI->FORM->{'list_osoby'}->columns_autosize;
    $MyUI->FORM->{'list_osoby'}->get_selection->set_mode('multiple');
    $MyUI->FORM->{'list_osoby'}->signal_connect("row-activated"=>"upravit_osobu");
    $i=0;
    foreach my $column ($MyUI->FORM->{'list_osoby'}->get_columns) {
        $column->set_resizable(1);
        $column->set_clickable(1);
        $column->set_sort_indicator(0);
        $column->set_sort_column_id($i);
        $column->set_min_width(10);
        $i++;
    };

    $MyUI->FORM->{'menu_skupiny'}=new MenuAdresar;
    $MyUI->FORM->{'menu_skupiny'}->FORM->{'item_opravit'}->signal_connect("activate","upravit_skupinu");
    $MyUI->FORM->{'menu_skupiny'}->FORM->{'item_pridat'}->signal_connect("activate","pridat_skupinu");
    $MyUI->FORM->{'menu_skupiny'}->FORM->{'item_kopirovat'}->signal_connect("activate","kopirovat_skupinu");
    $MyUI->FORM->{'menu_skupiny'}->FORM->{'item_vyjmout'}->signal_connect("activate","vyjmout_skupinu");
    
    $MyUI->FORM->{'menu_firmy'}=new MenuAdresar;
    $MyUI->FORM->{'menu_firmy'}->FORM->{'item_opravit'}->signal_connect("activate","upravit_firmu");
    $MyUI->FORM->{'menu_firmy'}->FORM->{'item_pridat'}->signal_connect("activate","pridat_firmu");
    $MyUI->FORM->{'menu_firmy'}->FORM->{'item_kopirovat'}->signal_connect("activate","kopirovat_firmu");
    $MyUI->FORM->{'menu_firmy'}->FORM->{'item_vyjmout'}->signal_connect("activate","vyjmout_firmu");

    $MyUI->FORM->{'menu_osoby'}=new MenuAdresar;
    $MyUI->FORM->{'menu_osoby'}->FORM->{'item_opravit'}->signal_connect("activate","upravit_osobu");
    $MyUI->FORM->{'menu_osoby'}->FORM->{'item_pridat'}->signal_connect("activate","pridat_osobu");
    $MyUI->FORM->{'menu_osoby'}->FORM->{'item_kopirovat'}->signal_connect("activate","kopirovat_osobu");
    $MyUI->FORM->{'menu_osoby'}->FORM->{'item_vyjmout'}->signal_connect("activate","vyjmout_osobu");

    if(!$MyMoney{'MainCfg'}->get('Adresar_show_skupiny')) {
        $MyMoney{'MainCfg'}->set('Adresar_show_skupiny','Y');
    };
    $MyUI->showhide_skupiny;
    if(!$MyMoney{'MainCfg'}->get('Adresar_show_firmy')) {
        $MyMoney{'MainCfg'}->set('Adresar_show_firmy','Y');
    };
    $MyUI->showhide_firmy;
    if(!$MyMoney{'MainCfg'}->get('Adresar_show_osoby')) {
        $MyMoney{'MainCfg'}->set('Adresar_show_osoby','Y');
    };
    $MyUI->showhide_osoby;
    
    if(!$MyMoney{'MainCfg'}->get('Adresar_firmy_jen_pro_skupinu')) {
        $MyMoney{'MainCfg'}->set('Adresar_firmy_jen_pro_skupinu','N');
    };
    if(!$MyMoney{'MainCfg'}->get('Adresar_osoby_jen_pro_firmu')) {
        $MyMoney{'MainCfg'}->set('Adresar_osoby_jen_pro_firmu','N');
    };
    $MyUI->nacist_seznam_skupin;
    if($MyMoney{'MainCfg'}->get('Adresar_firmy_jen_pro_skupinu') eq 'Y') {
        $MyUI->FORM->{'checkbutton_firmy_jen_pro_skupinu'}->set_active(1);
    } else {
        $MyUI->nacist_seznam_firem;
    };
    if($MyMoney{'MainCfg'}->get('Adresar_osoby_jen_pro_firmu') eq 'Y') {
       $MyUI->FORM->{'checkbutton_osoby_jen_pro_firmu'}->set_active(1);
    } else {
        $MyUI->nacist_seznam_osob;
    };
    
    $MyUI->TOPLEVEL->set_title('Adresar');
    $MyMoney{'MainCfg'}->window_open("Adresar",$MyUI->TOPLEVEL);
    if($MyMoney{'MainCfg'}->get('Adresar-paned_skupiny')) {
        $MyUI->FORM->{'paned_skupiny'}->set_position($MyMoney{'MainCfg'}->get('Adresar-paned_skupiny'));
    };
    if($MyMoney{'MainCfg'}->get('Adresar-paned_firmy')) {
        $MyUI->FORM->{'paned_firmy'}->set_position($MyMoney{'MainCfg'}->get('Adresar-paned_firmy'));
    };
    
    if(($self->{'selection_mode'} eq 'single') || ($self->{'selection_mode'} eq 'multiple')) {
        $MyUI->FORM->{'button_ok'}->show;
        $MyUI->FORM->{'button_prazdny'}->show;
    } else {
        $MyUI->FORM->{'button_ok'}->hide;
        $MyUI->FORM->{'button_prazdny'}->hide;
    };
    $MyUI->TOPLEVEL->show;
    Glib::Timeout->add (100, sub {1});
    Gtk2->main;
    return(@retval);
};

sub on_button_close_clicked {
    $MyMoney{'MainCfg'}->window_close("Adresar",$MyUI->TOPLEVEL);
    $MyMoney{'MainCfg'}->set('Adresar-paned_skupiny',$MyUI->FORM->{'paned_skupiny'}->get_position);
    $MyMoney{'MainCfg'}->set('Adresar-paned_firmy',$MyUI->FORM->{'paned_firmy'}->get_position);
    #$MyMoney{'MainCfg'}->seznam_close('Adresar_list_osoby',$MyUI->FORM->{'list_osoby'});
    $MyUI->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub on_Adresar_unrealize {
    $MyMoney{'MainCfg'}->window_close("Adresar",$MyUI->TOPLEVEL);
    $MyMoney{'MainCfg'}->set('Adresar-paned_skupiny',$MyUI->FORM->{'paned_skupiny'}->get_position);
    $MyMoney{'MainCfg'}->set('Adresar-paned_firmy',$MyUI->FORM->{'paned_firmy'}->get_position);
    Gtk2->main_quit;
};

sub on_button_prazdny_clicked {
    $MyMoney{'MainCfg'}->window_close("Adresar",$MyUI->TOPLEVEL);
    $MyMoney{'MainCfg'}->set('Adresar-paned_skupiny',$MyUI->FORM->{'paned_skupiny'}->get_position);
    $MyMoney{'MainCfg'}->set('Adresar-paned_firmy',$MyUI->FORM->{'paned_firmy'}->get_position);
    @retval=("0");
    $MyUI->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub on_button_ok_clicked {
    $MyMoney{'MainCfg'}->window_close("Adresar",$MyUI->TOPLEVEL);
    $MyMoney{'MainCfg'}->set('Adresar-paned_skupiny',$MyUI->FORM->{'paned_skupiny'}->get_position);
    $MyMoney{'MainCfg'}->set('Adresar-paned_firmy',$MyUI->FORM->{'paned_firmy'}->get_position);
    @retval=();
    for(my $i=0;$i<@{$MyUI->FORM->{'list_firmy'}->{data}};$i++) {
        my $pth=Gtk2::TreePath->new_from_indices($i);
        my $itr=$MyUI->FORM->{'list_firmy'}->get_model->get_iter($pth);
        if($MyUI->FORM->{'list_firmy'}->get_model->get_value($itr,0)==1) {
            push(@retval,$MyUI->FORM->{'list_firmy'}->get_model->get_value($itr,3))
        };
    };
    $MyUI->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub vybrat_firmu {
    $MyMoney{'MainCfg'}->window_close("Adresar",$MyUI->TOPLEVEL);
    $MyMoney{'MainCfg'}->set('Adresar-paned_skupiny',$MyUI->FORM->{'paned_skupiny'}->get_position);
    $MyMoney{'MainCfg'}->set('Adresar-paned_firmy',$MyUI->FORM->{'paned_firmy'}->get_position);
    my($list,$path,$column)=@_;
    my $iter=$MyUI->FORM->{'list_firmy'}->get_model->get_iter($path);
    @retval=$MyUI->FORM->{'list_firmy'}->get_model->get_value($iter,3);
    $MyUI->TOPLEVEL->hide;
    Gtk2->main_quit;
};

sub on_button_showskupiny_clicked {
    if($MyMoney{'MainCfg'}->get('Adresar_show_skupiny') eq 'Y') {
        $MyMoney{'MainCfg'}->set('Adresar_show_skupiny','N');
        $MyUI->FORM->{'list_skupiny'}->get_selection->set_mode('none');
        $MyUI->FORM->{'checkbutton_firmy_jen_pro_skupinu'}->set_active(0);
        $MyUI->FORM->{'checkbutton_firmy_jen_pro_skupinu'}->hide;
    } else {
        $MyMoney{'MainCfg'}->set('Adresar_show_skupiny','Y');
        $MyUI->FORM->{'checkbutton_firmy_jen_pro_skupinu'}->show;
        $MyUI->FORM->{'list_skupiny'}->get_selection->set_mode('multiple');
    };
    $MyUI->showhide_skupiny;
    $MyUI->FORM->{'paned_skupiny'}->set_position(0);
};

sub on_button_showfirmy_clicked {
    if($MyMoney{'MainCfg'}->get('Adresar_show_firmy') eq 'Y') {
        $MyMoney{'MainCfg'}->set('Adresar_show_firmy','N');
        $MyUI->FORM->{'checkbutton_osoby_jen_pro_firmu'}->set_active(0);
        $MyUI->FORM->{'checkbutton_osoby_jen_pro_firmu'}->hide;
    } else {
        $MyMoney{'MainCfg'}->set('Adresar_show_firmy','Y');
        $MyUI->FORM->{'checkbutton_osoby_jen_pro_firmu'}->show;
    };
    $MyUI->showhide_firmy;
    $MyUI->FORM->{'paned_firmy'}->set_position(0);
};

sub on_button_showosoby_clicked {
    if($MyMoney{'MainCfg'}->get('Adresar_show_osoby') eq 'Y') {
        $MyMoney{'MainCfg'}->set('Adresar_show_osoby','N');
    } else {
        $MyMoney{'MainCfg'}->set('Adresar_show_osoby','Y');
    };
    $MyUI->showhide_osoby;
    $MyUI->FORM->{'paned_firmy'}->set_position(10000);
};

sub showhide_skupiny {
    if($MyMoney{'MainCfg'}->get('Adresar_show_skupiny') eq 'Y') {
        $MyUI->FORM->{'scrolledwindow_skupiny'}->show;
        $MyUI->FORM->{'button_skupiny'}->show;
        $MyUI->FORM->{'list_skupiny'}->get_selection->set_mode('multiple');
        $MyUI->nacist_seznam_skupin;
    } else {
        $MyUI->FORM->{'scrolledwindow_skupiny'}->hide;
        $MyUI->FORM->{'button_skupiny'}->hide;
        $MyUI->FORM->{'list_skupiny'}->get_selection->set_mode('none');
    };
};

sub showhide_firmy {
    if($MyMoney{'MainCfg'}->get('Adresar_show_firmy') eq 'Y') {
        $MyUI->FORM->{'scrolledwindow_firmy'}->show;
        $MyUI->FORM->{'button_firmy'}->show;
        $MyUI->FORM->{'checkbutton_firmy_jen_pro_skupinu'}->show;
        $MyUI->FORM->{'list_firmy'}->get_selection->set_mode('multiple');
        $MyUI->nacist_seznam_firem;
    } else {
        $MyUI->FORM->{'scrolledwindow_firmy'}->hide;
        $MyUI->FORM->{'button_firmy'}->hide;
        $MyUI->FORM->{'checkbutton_firmy_jen_pro_skupinu'}->hide;
        $MyUI->FORM->{'list_firmy'}->get_selection->set_mode('none');
        if($MyUI->{'selection_mode'} ne 'none') {
            $MyUI->FORM->{'button_ok'}->set_sensitive(0);
        };
    };
};

sub showhide_osoby {
    if($MyMoney{'MainCfg'}->get('Adresar_show_osoby') eq 'Y') {
        $MyUI->FORM->{'scrolledwindow_osoby'}->show;
        $MyUI->FORM->{'button_osoby'}->show;
        $MyUI->FORM->{'checkbutton_osoby_jen_pro_firmu'}->show;
        $MyUI->nacist_seznam_osob;
    } else {
        $MyUI->FORM->{'scrolledwindow_osoby'}->hide;
        $MyUI->FORM->{'button_osoby'}->hide;
        $MyUI->FORM->{'checkbutton_osoby_jen_pro_firmu'}->hide;
    };
};

sub on_button_skupiny_clicked {
    my $parent=shift;

    if($MyUI->FORM->{'list_skupiny'}->get_selection->count_selected_rows==1) {
        $MyUI->FORM->{'menu_skupiny'}->FORM->{'item_opravit'}->set_sensitive(1);
        $MyUI->FORM->{'menu_skupiny'}->FORM->{'item_kopirovat'}->set_sensitive(1);
    } else {
        $MyUI->FORM->{'menu_skupiny'}->FORM->{'item_opravit'}->set_sensitive(0);
        $MyUI->FORM->{'menu_skupiny'}->FORM->{'item_kopirovat'}->set_sensitive(0);
    };
    if($MyUI->FORM->{'list_skupiny'}->get_selection->count_selected_rows) {
        $MyUI->FORM->{'menu_skupiny'}->FORM->{'item_vyjmout'}->set_sensitive(1);
    } else {
        $MyUI->FORM->{'menu_skupiny'}->FORM->{'item_vyjmout'}->set_sensitive(0);
    };
    $MyUI->FORM->{'menu_skupiny'}->TOPLEVEL->popup(undef, # parent menu shell
                 undef, # parent menu item
                 undef, # menu pos func
                 undef, # data
                 $parent,
                 0);
};

sub on_button_firmy_clicked {
    my $button=shift;

    if($MyUI->FORM->{'list_firmy'}->get_selection->count_selected_rows==1) {
        $MyUI->FORM->{'menu_firmy'}->FORM->{'item_opravit'}->set_sensitive(1);
        $MyUI->FORM->{'menu_firmy'}->FORM->{'item_kopirovat'}->set_sensitive(1);
    } else {
        $MyUI->FORM->{'menu_firmy'}->FORM->{'item_opravit'}->set_sensitive(0);
        $MyUI->FORM->{'menu_firmy'}->FORM->{'item_kopirovat'}->set_sensitive(0);
    };
    if($MyUI->FORM->{'list_firmy'}->get_selection->count_selected_rows) {
        $MyUI->FORM->{'menu_firmy'}->FORM->{'item_vyjmout'}->set_sensitive(1);
    } else {
        $MyUI->FORM->{'menu_firmy'}->FORM->{'item_vyjmout'}->set_sensitive(0);
    };
    $MyUI->FORM->{'menu_firmy'}->TOPLEVEL->popup(undef, # parent menu shell
                 undef, # parent menu item
                 undef, # menu pos func
                 undef, # data
                 $button,
                 0);
};

sub on_button_osoby_clicked {
    my $button=shift;

    if($MyUI->FORM->{'list_osoby'}->get_selection->count_selected_rows==1) {
        $MyUI->FORM->{'menu_osoby'}->FORM->{'item_opravit'}->set_sensitive(1);
        $MyUI->FORM->{'menu_osoby'}->FORM->{'item_kopirovat'}->set_sensitive(1);
    } else {
        $MyUI->FORM->{'menu_osoby'}->FORM->{'item_opravit'}->set_sensitive(0);
        $MyUI->FORM->{'menu_osoby'}->FORM->{'item_kopirovat'}->set_sensitive(0);
    };
    if($MyUI->FORM->{'list_osoby'}->get_selection->count_selected_rows) {
        $MyUI->FORM->{'menu_osoby'}->FORM->{'item_vyjmout'}->set_sensitive(1);
    } else {
        $MyUI->FORM->{'menu_osoby'}->FORM->{'item_vyjmout'}->set_sensitive(0);
    };
    if($MyUI->FORM->{'list_firmy'}->get_selection->count_selected_rows==1) {
        my ($path)=$MyUI->FORM->{'list_firmy'}->get_selection->get_selected_rows;
        my $iter=$MyUI->FORM->{'list_firmy'}->get_model->get_iter($path);
        if($MyUI->FORM->{'list_firmy'}->get_model->get($iter,31) eq "Ano") {
            $MyUI->FORM->{'menu_osoby'}->FORM->{'item_pridat'}->set_sensitive(0);
        } else {
            $MyUI->FORM->{'menu_osoby'}->FORM->{'item_pridat'}->set_sensitive(1);
        };
    } else {
        $MyUI->FORM->{'menu_osoby'}->FORM->{'item_pridat'}->set_sensitive(0);
    };
    
    #
    # jine chovani u osobo, ktere jsou majiteli firmy (firmajeosoba)
    #
    my $selected_rows_mayberemoved=0;
    foreach my $path ($MyUI->FORM->{'list_osoby'}->get_selection->get_selected_rows) {
        my $iter=$MyUI->FORM->{'list_osoby'}->get_model->get_iter($path);
        if($MyUI->FORM->{'list_osoby'}->get_model->get($iter,18) eq "Ano") {
            $MyUI->FORM->{'menu_osoby'}->FORM->{'item_kopirovat'}->set_sensitive(0);
        } else {
            $selected_rows_mayberemoved++;
        };
    };
    if($selected_rows_mayberemoved) {
        $MyUI->FORM->{'menu_osoby'}->FORM->{'item_vyjmout'}->set_sensitive(1);
    } else {
        $MyUI->FORM->{'menu_osoby'}->FORM->{'item_vyjmout'}->set_sensitive(0);
    };
    
    $MyUI->FORM->{'menu_osoby'}->TOPLEVEL->popup(undef, # parent menu shell
                 undef, # parent menu item
                 undef, # menu pos func
                 undef, # data
                 $button,
                 0);
};

sub list_skupiny_menu_activate {
    my ($slist,$eventbutton)=@_;
    if($eventbutton->button eq 3) {
        Adresar::on_button_skupiny_clicked($MyUI->FORM->{'list_skupiny'});
    };
};

sub list_firmy_menu_activate {
    my ($slist,$eventbutton)=@_;
    if($eventbutton->button eq 3) {
        Adresar::on_button_firmy_clicked($MyUI->FORM->{'list_firmy'});
    };
};

sub list_osoby_menu_activate {
    my ($slist,$eventbutton)=@_;
    if($eventbutton->button eq 3) {
        Adresar::on_button_osoby_clicked($MyUI->FORM->{'list_osoby'});
    };
};


sub pridat_skupinu {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $KartaSkupinyAdresare=new KartaSkupinyAdresare;
    if(my $retval=$KartaSkupinyAdresare->pridat(%MyMoney)) {
        push(@{$MyUI->FORM->{'list_skupiny'}->{data}},[$retval->get('nazev'),$retval->get('id')]);
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub upravit_skupinu {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $KartaSkupinyAdresare=new KartaSkupinyAdresare;
    my $path=$MyUI->FORM->{'list_skupiny'}->get_selection->get_selected_rows;
    my $iter=$MyUI->FORM->{'list_skupiny'}->get_model->get_iter($path);
    my $id=$MyUI->FORM->{'list_skupiny'}->get_model->get($iter,1);
    if(my $retval=$KartaSkupinyAdresare->upravit("id='".$id."'",%MyMoney)) {
        my $i=0;
        foreach $_ ("nazev","id") {
            $MyUI->FORM->{'list_skupiny'}->get_model->set($iter,$i,$retval->get($_));
            $i++;
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub kopirovat_skupinu {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $KartaSkupinyAdresare=new KartaSkupinyAdresare;
    my $path=$MyUI->FORM->{'list_skupiny'}->get_selection->get_selected_rows;
    my $iter=$MyUI->FORM->{'list_skupiny'}->get_model->get_iter($path);
    my $id=$MyUI->FORM->{'list_skupiny'}->get_model->get($iter,1);
    if(my $retval=$KartaSkupinyAdresare->kopirovat("id='".$id."'",%MyMoney)) {
        push(@{$MyUI->FORM->{'list_skupiny'}->{data}},[$retval->get('nazev'),$retval->get('id')]);
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub vyjmout_skupinu {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Dialog=new Dialog;
    if($Dialog->show('text'=>'Opravdu chcete smazat oznacene zaznamy?','type'=>'question')) {
        my $KartaSkupinyAdresare=new KartaSkupinyAdresare;
        my @paths=$MyUI->FORM->{'list_skupiny'}->get_selection->get_selected_rows;
        my $err=0;
        for(my $j=(@paths-1); $j>=0; $j--) {
            my $path=$paths[$j];
            my $iter=$MyUI->FORM->{'list_skupiny'}->get_model->get_iter($path);
            my $id=$MyUI->FORM->{'list_skupiny'}->get_model->get($iter,1);
            if((my $Table=$KartaSkupinyAdresare->odstranit("id='".$id."'",%MyMoney))) {
                $MyUI->FORM->{'list_skupiny'}->get_selection->set_mode('none');
                $MyUI->FORM->{'list_skupiny'}->get_model->remove($iter);
                $MyUI->FORM->{'list_skupiny'}->get_selection->set_mode('multiple');
            } else {
                $err++;
            };
        };
        if($err) {
            my $Dialog=new Dialog;
            $Dialog->show('text'=>"Nektere zaznamy se nepodarilo smazat.\nZrejme byl zaznam uzamcen, nebo zmenen jinym uzivatelem.",'type'=>'info');
        };
        $MyUI->nacist_seznam_firem;
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub nacist_seznam_skupin {
    if($MyMoney{'MainCfg'}->get('Adresar_show_skupiny') eq 'Y') {
        $MyUI->FORM->{'list_skupiny'}->get_selection->set_mode('none');
        @{$MyUI->FORM->{'list_skupiny'}->{data}}=();
        my $Databaze=new Databaze(%MyMoney);
        $Databaze->Read("a".$MyMoney{'AgendaData'}->get('id')."_AdrSkup","","nazev","id");
        for(my $i=0;$i<$Databaze->numrows;$i++) {
            my %row=$Databaze->fetchhash;
            push(@{$MyUI->FORM->{'list_skupiny'}->{data}},[$row{'nazev'},$row{'id'}]);
        };
        $MyUI->FORM->{'list_skupiny'}->get_selection->set_mode('multiple');
    };
};

sub skupiny_selection_changed {
    if($MyUI->FORM->{'checkbutton_firmy_jen_pro_skupinu'}->get_active) {
        $MyUI->nacist_seznam_firem;
    };
};

sub pridat_firmu {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $skupina_id=0;
    if($MyUI->FORM->{'list_skupiny'}->get_selection->count_selected_rows==1) {
        my $path=$MyUI->FORM->{'list_skupiny'}->get_selection->get_selected_rows;
        my $iter=$MyUI->FORM->{'list_skupiny'}->get_model->get_iter($path);
        $skupina_id=$MyUI->FORM->{'list_skupiny'}->get_model->get($iter,1);
    };
    my $KartaAdresare=new KartaAdresare;
    if(my $retval=$KartaAdresare->pridat($skupina_id,%MyMoney)) {
        if($retval->get('firmajeosoba')) {
            $retval->set('firmajeosoba','Ano');
        } else {
            $retval->set('firmajeosoba','Ne');
        };
        push(@{$MyUI->FORM->{'list_firmy'}->{data}},[0,$retval->get("pr_nazev"),$retval->get("ean"),$retval->get("id"),$retval->get("ob_nazev"),$retval->get("ob_ulice"),$retval->get("ob_mesto"),$retval->get("ob_psc"),$retval->get("ob_statnazev"),$retval->get("ob_statzkrat"),$retval->get("pr_ulice"),$retval->get("pr_mesto"),$retval->get("pr_psc"),$retval->get("pr_statnazev"),$retval->get("pr_statzkrat"),$retval->get("telpred"),$retval->get("tel"),$retval->get("telklap"),$retval->get("faxpred"),$retval->get("fax"),$retval->get("faxklap"),$retval->get("email"),$retval->get("www"),$retval->get("mobilpred"),$retval->get("mobil"),$retval->get("ico"),$retval->get("dic"),"???","???",$retval->get("ucet"),$retval->get("bkod"),$retval->get("firmajeosoba")]);
        $MyUI->nacist_seznam_osob;
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub upravit_firmu {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $KartaAdresare=new KartaAdresare;
    my $path=$MyUI->FORM->{'list_firmy'}->get_selection->get_selected_rows;
    my $iter=$MyUI->FORM->{'list_firmy'}->get_model->get_iter($path);
    my $id=$MyUI->FORM->{'list_firmy'}->get_model->get($iter,3);
    if(my $retval=$KartaAdresare->upravit("id='".$id."'",%MyMoney)) {
        my $upravit_zaznam=0;
        if($MyUI->FORM->{'checkbutton_firmy_jen_pro_skupinu'}->get_active) {
            my @skupiny=();
            if($MyUI->FORM->{'list_skupiny'}->get_selection->count_selected_rows==0) {
                @skupiny=(0);
            } else {
                my $model=$MyUI->FORM->{'list_skupiny'}->get_model;
                my @paths=$MyUI->FORM->{'list_skupiny'}->get_selection->get_selected_rows;
                for(my $j=(@paths-1); $j>=0; $j--) {
                    my $path=$paths[$j];
                    my $iter_s=$model->get_iter($path);
                    push(@skupiny,$model->get($iter_s,1));
                };
            };
            $upravit_zaznam=0;
            foreach $_ (@skupiny) {
                if($_ eq $retval->get('skupina_id')) {
                    $upravit_zaznam=1;
                };
            };
        } else {
            $upravit_zaznam=1;
        };
        if($upravit_zaznam) {
            my $i=1;
            if($retval->get('firmajeosoba')) {
                $retval->set('firmajeosoba','Ano');
            } else {
                $retval->set('firmajeosoba','Ne');
            };
            foreach $_ ("pr_nazev","ean","id","ob_nazev","ob_ulice","ob_mesto","ob_psc","ob_statnazev","ob_statzkrat","pr_ulice","pr_mesto","pr_psc","pr_statnazev","pr_statzkrat","telpred","tel","telklap","faxpred","fax","faxklap","email","www","mobilpred","mobil","ico","dic","???","???","ucet","bkod","firmajeosoba") {
                $MyUI->FORM->{'list_firmy'}->get_model->set($iter,$i,$retval->get($_));
                $i++;
            };
        } else {
            # skupina byla zmenena a zaznam se nyni jiz nezobrazuje
            $MyUI->FORM->{'list_firmy'}->get_selection->set_mode('none');
            $MyUI->FORM->{'list_firmy'}->get_model->remove($iter);
            $MyUI->FORM->{'list_firmy'}->get_selection->set_mode('multiple');
        };
        $MyUI->nacist_seznam_osob;
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub kopirovat_firmu {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $KartaAdresare=new KartaAdresare;
    my $path=$MyUI->FORM->{'list_firmy'}->get_selection->get_selected_rows;
    my $iter=$MyUI->FORM->{'list_firmy'}->get_model->get_iter($path);
    my $id=$MyUI->FORM->{'list_firmy'}->get_model->get($iter,3);
    if(my $retval=$KartaAdresare->kopirovat("id='".$id."'",%MyMoney)) {
        if($retval->get('firmajeosoba')) {
            $retval->set('firmajeosoba','Ano');
        } else {
            $retval->set('firmajeosoba','Ne');
        };
        push(@{$MyUI->FORM->{'list_firmy'}->{data}},[0,$retval->get("pr_nazev"),$retval->get("ean"),$retval->get("id"),$retval->get("ob_nazev"),$retval->get("ob_ulice"),$retval->get("ob_mesto"),$retval->get("ob_psc"),$retval->get("ob_statnazev"),$retval->get("ob_statzkrat"),$retval->get("pr_ulice"),$retval->get("pr_mesto"),$retval->get("pr_psc"),$retval->get("pr_statnazev"),$retval->get("pr_statzkrat"),$retval->get("telpred"),$retval->get("tel"),$retval->get("telklap"),$retval->get("faxpred"),$retval->get("fax"),$retval->get("faxklap"),$retval->get("email"),$retval->get("www"),$retval->get("mobilpred"),$retval->get("mobil"),$retval->get("ico"),$retval->get("dic"),"???","???",$retval->get("ucet"),$retval->get("bkod"),$retval->get('firmajeosoba')]);
        $MyUI->nacist_seznam_osob;
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub vyjmout_firmu {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Dialog=new Dialog;
    if($Dialog->show('text'=>'Opravdu chcete smazat oznacene zaznamy?','type'=>'question')) {
        my $KartaAdresare=new KartaAdresare;
        my @paths=$MyUI->FORM->{'list_firmy'}->get_selection->get_selected_rows;
        my $err=0;
        for(my $j=(@paths-1); $j>=0; $j--) {
            my $path=$paths[$j];
            my $iter=$MyUI->FORM->{'list_firmy'}->get_model->get_iter($path);
            my $id=$MyUI->FORM->{'list_firmy'}->get_model->get($iter,3);
            if((my $Table=$KartaAdresare->odstranit("id='".$id."'",%MyMoney))) {
                $MyUI->FORM->{'list_firmy'}->get_selection->set_mode('none');
                $MyUI->FORM->{'list_firmy'}->get_model->remove($iter);
                $MyUI->FORM->{'list_firmy'}->get_selection->set_mode('multiple');
            } else {
                $err++;
            };
        };
        if($err) {
            my $Dialog=new Dialog;
            $Dialog->show('text'=>"Nektere zaznamy se nepodarilo smazat.\nZrejme byl zaznam uzamcen, nebo zmenen jinym uzivatelem.",'type'=>'info');
        };
        $MyUI->nacist_seznam_osob;
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub nacist_seznam_firem {
    if($MyMoney{'MainCfg'}->get('Adresar_show_firmy') eq 'Y') {
        $MyUI->FORM->{'list_firmy'}->get_selection->set_mode('none');
        @{$MyUI->FORM->{'list_firmy'}->{data}}=();
        my $where="";
        if($MyUI->FORM->{'checkbutton_firmy_jen_pro_skupinu'}->get_active) {
            if($MyUI->FORM->{'list_skupiny'}->get_selection->count_selected_rows==0) {
                my $Databaze=new Databaze(%MyMoney);
                $Databaze->Read("a".$MyMoney{'AgendaData'}->get('id')."_AdrSkup","","id");
                for(my $i=0;$i<$Databaze->numrows;$i++) {
                    if($where) {
                        $where.=",";
                    };
                    my %row=$Databaze->fetchhash;
                    $where.="'".$row{id}."'";
                };
                if($where) {
                    $where="skupina_id NOT IN (".$where.")";
                };
            } else {
                my $model=$MyUI->FORM->{'list_skupiny'}->get_model;
                my @paths=$MyUI->FORM->{'list_skupiny'}->get_selection->get_selected_rows;
                for(my $j=(@paths-1); $j>=0; $j--) {
                    my $path=$paths[$j];
                    my $iter=$model->get_iter($path);
                    if($where) {
                        $where.=",";
                    };
                    $where.=$model->get($iter,1);
                };
                $where="skupina_id IN (".$where.")";
            };
        };
        my $Databaze=new Databaze(%MyMoney);
        $Databaze->Read("a".$MyMoney{'AgendaData'}->get('id')."_AdresarF",$where,"pr_nazev","ean","id","ob_nazev","ob_ulice","ob_mesto","ob_psc","ob_statnazev","ob_statzkrat","pr_ulice","pr_mesto","pr_psc","pr_statnazev","pr_statzkrat","telpred","tel","telklap","faxpred","fax","faxklap","email","www","mobilpred","mobil","ico","dic","ucet","bkod","firmajeosoba");
        for(my $i=0;$i<$Databaze->numrows;$i++) {
            my %row=$Databaze->fetchhash;
            if($row{firmajeosoba}) {
                $row{firmajeosoba}="Ano";
            } else {
                $row{firmajeosoba}="Ne";
            };
            push(@{$MyUI->FORM->{'list_firmy'}->{data}},[0,$row{"pr_nazev"},$row{"ean"},$row{"id"},$row{"ob_nazev"},$row{"ob_ulice"},$row{"ob_mesto"},$row{"ob_psc"},$row{"ob_statnazev"},$row{"ob_statzkrat"},$row{"pr_ulice"},$row{"pr_mesto"},$row{"pr_psc"},$row{"pr_statnazev"},$row{"pr_statzkrat"},$row{"telpred"},$row{"tel"},$row{"telklap"},$row{"faxpred"},$row{"fax"},$row{"faxklap"},$row{"email"},$row{"www"},$row{"mobilpred"},$row{"mobil"},$row{"ico"},$row{"dic"},"???","???",$row{"ucet"},$row{"bkod"},$row{firmajeosoba}]);
        };
        $MyUI->FORM->{'list_firmy'}->get_selection->set_mode('multiple');
        if($MyUI->{'selection_mode'} ne 'none') {
            $MyUI->enable_ok_butt;
        };
    };
};

sub firmy_selection_changed {
    if(($MyUI->{'selection_mode'} ne 'none') && ($MyMoney{'MainCfg'}->get('Adresar_show_firmy') eq 'Y')) {
        if($MyUI->{'selection_mode'} eq 'single') {
            my($path,$column)=$MyUI->FORM->{'list_firmy'}->get_cursor;
            my $iter=$MyUI->FORM->{'list_firmy'}->get_model->get_iter($path);
            if($MyUI->FORM->{'list_firmy'}->get_model->get_value($iter,0)==1) {
                $MyUI->FORM->{'list_firmy'}->get_model->set_value($iter,0,0);
                #delete($checked_rows{$path->get_indices});
            } else {
                if($MyUI->{'selection_mode'} eq 'single') {
                    for(my $i=0;$i<@{$MyUI->FORM->{'list_firmy'}->{data}};$i++) {
                        my $pth=Gtk2::TreePath->new_from_indices($i);
                        my $itr=$MyUI->FORM->{'list_firmy'}->get_model->get_iter($pth);
                        $MyUI->FORM->{'list_firmy'}->get_model->set_value($itr,0,0);
                    };
                };
                $MyUI->FORM->{'list_firmy'}->get_model->set_value($iter,0,1);
                #if($self->{'seltype'} eq 'single') {
                #    foreach $_ (keys(%checked_rows)) {
                #        my $uncheck_path=Gtk2::TreePath->new_from_indices($_);
                #        my $iter=$window->FORM->{'model'}->get_iter($uncheck_path);
                #        $window->FORM->{'model'}->set_value($iter,0,0);
                #        delete($checked_rows{$_});
                #    };
                #};
                #$checked_rows{$path->get_indices}=1;
            };
        };
        $MyUI->enable_ok_butt;
    };
    if($MyUI->FORM->{'checkbutton_osoby_jen_pro_firmu'}->get_active) {
        $MyUI->nacist_seznam_osob;
    };
};

sub enable_ok_butt {
    my $selected_rows=0;
    for(my $i=0;$i<@{$MyUI->FORM->{'list_firmy'}->{data}};$i++) {
        my $pth=Gtk2::TreePath->new_from_indices($i);
        my $itr=$MyUI->FORM->{'list_firmy'}->get_model->get_iter($pth);
        if($MyUI->FORM->{'list_firmy'}->get_model->get_value($itr,0)==1) {
            $selected_rows++;
        };
    };
    if($selected_rows) {
        $MyUI->FORM->{'button_ok'}->set_sensitive(1);
    } else {
        $MyUI->FORM->{'button_ok'}->set_sensitive(0);
    };    
};

sub nacist_seznam_osob {
    if($MyMoney{'MainCfg'}->get('Adresar_show_osoby') eq 'Y') {
        $MyUI->FORM->{'list_osoby'}->get_selection->set_mode('none');
        @{$MyUI->FORM->{'list_osoby'}->{data}}=();
        my $where="";
        if($MyUI->FORM->{'checkbutton_osoby_jen_pro_firmu'}->get_active) {
            if($MyUI->FORM->{'list_firmy'}->get_selection->count_selected_rows==0) {
                $MyUI->FORM->{'list_osoby'}->get_selection->set_mode('multiple');
                return
            } else {
                my $model=$MyUI->FORM->{'list_firmy'}->get_model;
                my @paths=$MyUI->FORM->{'list_firmy'}->get_selection->get_selected_rows;
                for(my $j=(@paths-1); $j>=0; $j--) {
                    my $path=$paths[$j];
                    my $iter=$model->get_iter($path);
                    if($where) {
                        $where.=",";
                    };
                    $where.=$model->get($iter,3);
                };
                $where="firma_id IN (".$where.")";
            };
        };
        my $Databaze=new Databaze(%MyMoney);
        my $DatabazeF=new Databaze(%MyMoney);
        $Databaze->Read("a".$MyMoney{'AgendaData'}->get('id')."_AdresarO",$where,"prijmeni","jmeno","ean","funkce","ulice","mesto","psc","statnazev","telpred","tel","telklap","faxpred","fax","faxklap","email","mobilpred","mobil","firma_id","id");
        for(my $i=0;$i<$Databaze->numrows;$i++) {
            my %row=$Databaze->fetchhash;
            $DatabazeF->Read("a".$MyMoney{'AgendaData'}->get('id')."_AdresarF","id='".$row{'firma_id'}."'","ob_nazev","firmajeosoba");
            my %firma=$DatabazeF->fetchhash;
            $row{'firma_nazev'}=$firma{'ob_nazev'};
            if($firma{'firmajeosoba'}) {
                $row{'majitel_firmy'}="Ano";
            } else {
                $row{'majitel_firmy'}="Ne";
            };
            push(@{$MyUI->FORM->{'list_osoby'}->{data}},[$row{"prijmeni"},$row{"jmeno"},$row{"ean"},$row{"funkce"},$row{"ulice"},$row{"mesto"},$row{"psc"},$row{"statnazev"},$row{"telpred"},$row{"tel"},$row{"telklap"},$row{"faxpred"},$row{"fax"},$row{"faxklap"},$row{"email"},$row{"mobilpred"},$row{"mobil"},$row{"firma_nazev"},$row{"majitel_firmy"},$row{"id"}]);
        };
        $MyUI->FORM->{'list_osoby'}->get_selection->set_mode('multiple');
    };
};

sub pridat_osobu {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $KartaKontaktniOsoby=new KartaKontaktniOsoby;
    my $path=$MyUI->FORM->{'list_firmy'}->get_selection->get_selected_rows;
    my $iter=$MyUI->FORM->{'list_firmy'}->get_model->get_iter($path);
    my $firma_id=$MyUI->FORM->{'list_firmy'}->get_model->get($iter,3);
    if(my $retval=$KartaKontaktniOsoby->pridat(0,$firma_id,%MyMoney)) {
        my $DatabazeF=new Databaze(%MyMoney);
        $DatabazeF->Read("a".$MyMoney{'AgendaData'}->get('id')."_AdresarF","id='".$retval->get('firma_id')."'","ob_nazev"."firmajeosoba");
        my %firma=$DatabazeF->fetchhash;
        if($firma{'firmajeosoba'}) {
            $firma{'majitel_firmy'}="Ano";
        } else {
            $firma{'majitel_firmy'}="Ne";
        };
        push(@{$MyUI->FORM->{'list_osoby'}->{data}},[$retval->get("prijmeni"),$retval->get("jmeno"),$retval->get("ean"),$retval->get("funkce"),$retval->get("ulice"),$retval->get("mesto"),$retval->get("psc"),$retval->get("statnazev"),$retval->get("telpred"),$retval->get("tel"),$retval->get("telklap"),$retval->get("faxpred"),$retval->get("fax"),$retval->get("faxklap"),$retval->get("email"),$retval->get("mobilpred"),$retval->get("mobil"),$firma{"ob_nazev"},$firma{'majitel_firmy'},$retval->get("id")]);
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub upravit_osobu {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $KartaKontaktniOsoby=new KartaKontaktniOsoby;
    my @path=$MyUI->FORM->{'list_osoby'}->get_selection->get_selected_rows;
    my $iter=$MyUI->FORM->{'list_osoby'}->get_model->get_iter($path[0]);
    my $id=$MyUI->FORM->{'list_osoby'}->get_model->get($iter,19);
    if(my $retval=$KartaKontaktniOsoby->upravit(0,"id='".$id."'",%MyMoney)) {
        my $i=0;
        my $DatabazeF=new Databaze(%MyMoney);
        $DatabazeF->Read("a".$MyMoney{'AgendaData'}->get('id')."_AdresarF","id='".$retval->get('firma_id')."'","ob_nazev","firmajeosoba");
        my %firma=$DatabazeF->fetchhash;
        $retval->set('firma_nazev',$firma{'ob_nazev'});
        if($firma{'firmajeosoba'}) {
            $retval->set('majitel_firmy',"Ano");
        } else {
            $retval->set('majitel_firmy',"Ne");
        };
        foreach $_ ("prijmeni","jmeno","ean","funkce","ulice","mesto","psc","statnazev","telpred","tel","telklap","faxpred","fax","faxklap","email","mobilpred","mobil","firma_nazev","majitel_firmy","id") {
            $MyUI->FORM->{'list_osoby'}->get_model->set($iter,$i,$retval->get($_));
            $i++;
        };
        if(($retval->get('majitel_firmy')) && ($MyMoney{'MainCfg'}->get('Adresar_show_firmy') eq 'Y')) {
            my $firma_id=$retval->get('firma_id');
            $retval=new Table('a_AdresarF',%MyMoney);
            $retval->load("id='".$firma_id."'");
            if($retval->get('firmajeosoba')) {
                $retval->set('firmajeosoba','Ano');
            } else {
                $retval->set('firmajeosoba','Ne');
            };
            $i=0;
            foreach $_ (@{$MyUI->FORM->{'list_firmy'}->{data}}) {
                my @firma=@{$_};
                if($firma[2] eq $firma_id) {
                    $_=[$firma[0],$retval->get("pr_nazev"),$retval->get("ean"),$retval->get("id"),$retval->get("ob_nazev"),$retval->get("ob_ulice"),$retval->get("ob_mesto"),$retval->get("ob_psc"),$retval->get("ob_statnazev"),$retval->get("ob_statzkrat"),$retval->get("pr_ulice"),$retval->get("pr_mesto"),$retval->get("pr_psc"),$retval->get("pr_statnazev"),$retval->get("pr_statzkrat"),$retval->get("telpred"),$retval->get("tel"),$retval->get("telklap"),$retval->get("faxpred"),$retval->get("fax"),$retval->get("faxklap"),$retval->get("email"),$retval->get("www"),$retval->get("mobilpred"),$retval->get("mobil"),$retval->get("ico"),$retval->get("dic"),"???","???",$retval->get("ucet"),$retval->get("bkod"),$retval->get('firmajeosoba')];
                };
            };
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub kopirovat_osobu {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $KartaKontaktniOsoby=new KartaKontaktniOsoby;
    my $path=$MyUI->FORM->{'list_osoby'}->get_selection->get_selected_rows;
    my $iter=$MyUI->FORM->{'list_osoby'}->get_model->get_iter($path);
    my $id=$MyUI->FORM->{'list_osoby'}->get_model->get($iter,19);
    if(my $retval=$KartaKontaktniOsoby->kopirovat(0,"id='".$id."'",%MyMoney)) {
        my $DatabazeF=new Databaze(%MyMoney);
        $DatabazeF->Read("a".$MyMoney{'AgendaData'}->get('id')."_AdresarF","id='".$retval->get('firma_id')."'","ob_nazev");
        my %firma=$DatabazeF->fetchhash;
        if($firma{'firmajeosoba'}) {
            $retval->set('majitel_firmy',"Ano");
        } else {
            $retval->set('majitel_firmy',"Ne");
        };
        push(@{$MyUI->FORM->{'list_osoby'}->{data}},[$retval->get("prijmeni"),$retval->get("jmeno"),$retval->get("ean"),$retval->get("funkce"),$retval->get("ulice"),$retval->get("mesto"),$retval->get("psc"),$retval->get("statnazev"),$retval->get("telpred"),$retval->get("tel"),$retval->get("telklap"),$retval->get("faxpred"),$retval->get("fax"),$retval->get("faxklap"),$retval->get("email"),$retval->get("mobilpred"),$retval->get("mobil"),$firma{"ob_nazev"},$retval->get('majitel_firmy'),$retval->get("id")]);
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub vyjmout_osobu {
    $MyUI->{'TOPFORM'}->set_sensitive(0);
    my $Dialog=new Dialog;
    if($Dialog->show('text'=>'Opravdu chcete smazat oznacene zaznamy?','type'=>'question')) {
        my $KartaKontaktniOsoby=new KartaKontaktniOsoby;
        my @paths=$MyUI->FORM->{'list_osoby'}->get_selection->get_selected_rows;
        my $err=0;
        for(my $j=(@paths-1); $j>=0; $j--) {
            my $path=$paths[$j];
            my $iter=$MyUI->FORM->{'list_osoby'}->get_model->get_iter($path);
            my $id=$MyUI->FORM->{'list_osoby'}->get_model->get($iter,19);
            if((my $Table=$KartaKontaktniOsoby->odstranit("id='".$id."'",%MyMoney))) {
                $MyUI->FORM->{'list_osoby'}->get_selection->set_mode('none');
                $MyUI->FORM->{'list_osoby'}->get_model->remove($iter);
                $MyUI->FORM->{'list_osoby'}->get_selection->set_mode('multiple');
            } else {
                $err++;
            };
        };
        if($err) {
            my $Dialog=new Dialog;
            $Dialog->show('text'=>"Nektere zaznamy se nepodarilo smazat.\nZrejme byl zaznam uzamcen, nebo zmenen jinym uzivatelem.",'type'=>'info');
        };
    };
    $MyUI->{'TOPFORM'}->set_sensitive(1);
};

sub on_checkbutton_firmy_jen_pro_skupinu_toggled {
    if($MyUI->FORM->{'checkbutton_firmy_jen_pro_skupinu'}->get_active) {
        $MyMoney{'MainCfg'}->set('Adresar_firmy_jen_pro_skupinu','Y');
    } else {
        $MyMoney{'MainCfg'}->set('Adresar_firmy_jen_pro_skupinu','N');
    };
    $MyUI->nacist_seznam_firem;
};

sub on_checkbutton_osoby_jen_pro_firmu_toggled {
    if($MyUI->FORM->{'checkbutton_osoby_jen_pro_firmu'}->get_active) {
        $MyMoney{'MainCfg'}->set('Adresar_osoby_jen_pro_firmu','Y');
    } else {
        $MyMoney{'MainCfg'}->set('Adresar_osoby_jen_pro_firmu','N');
    };
    $MyUI->nacist_seznam_osob;
};

1;
